<template lang="pug">
q-card
  q-card-section
    .row
      .col
        .row.items-baseline
          .text-h6.q-ml-md Current Rooms:
        .row.justify-center
          q-spinner.q-my-lg(
            v-if="currentBreakoutRooms.loading",
            color="primary",
            size="3em"
          )
          q-card.q-ma-md(
            v-for="(room, id) in currentBreakoutRooms",
            v-if="(room || {}).isInBO || id === 'ZoomSensor_1'",
            style="max-width: 20rem",
            :key="id"
          )
            q-card-section.q-pb-none.pluginBold {{ id }}:
            q-card-section.q-pt-sm
              q-list(dense, separator)
                q-item(v-for="(user, uid) in (room || {}).users", :key="uid")
                  q-item-section {{ user.username }} ({{ user.userId }})
                q-item(v-if="!((room || {}).users || []).length")
                  q-item-section No Users in Room

      q-separator(vertical, inset, spaced)

      .col
        .row.items-baseline
          .text-h6.q-ml-md Room Assignment:

        .row.justify-center
          //-  We do an explicit check for true, in case someone names their room 'loading'
          q-spinner.q-my-lg(
            v-if="currentBreakoutRoomAssignment.loading === true",
            color="primary",
            size="3em"
          )
          .col(v-if="currentBreakoutRoomAssignment.loading !== true")
            BreakoutRoomAssignment(
              v-for="(room, roomName) in currentBreakoutRoomAssignment",
              :key="roomName",
              :room="room",
              :roomName="roomName",
              :onParticipantDragDropped="dropEnd",
              :editName="handleEditRoomName",
              :roomExists="roomExists"
            )
            .text-center.q-mt-lg.text-caption(
              v-if="!Object.entries(currentBreakoutRoomAssignment).length"
            ) No Breakout Room Assignment
</template>
<script>
import BreakoutRoomAssignment from "./BreakoutRoomAssignment.vue";

export default {
  props: {
    currentBreakoutRoomAssignment: { required: true },
    currentBreakoutRooms: { required: true },
    renameRoom: { required: true },
    firebase: { required: true },
    meetingId: { required: true },
  },
  methods: {
    dropEnd() {
      this.firebase
        .ref(
          `config/${this.meetingId}/current/currentState/plugins/task/breakout rooms/assignment`
        )
        .set(this.currentBreakoutRoomAssignment);
    },
    roomExists(roomName) {
      return Boolean(this.currentBreakoutRoomAssignment[roomName]);
    },
    async handleEditRoomName(oldName, newName) {
      return this.renameRoom(oldName, newName);
    },
  },
  components: {
    BreakoutRoomAssignment,
  },
};
</script>
<style scoped>
.pluginBold {
  font-weight: bold;
}
</style>
